http://acm.hdu.edu.cn/showproblem.php?pid=4815
Problem Description
A crowd of little animals is visiting a mysterious laboratory – The Deep Lab of SYSU.
“Are you surprised by the STS (speech to speech) technology of Microsoft Research and the cat face recognition project of Google and academia? Are you curious about what technology is behind those fantastic demos?” asks the director of the Deep Lab. “Deep learning, deep learning!” Little Tiger raises his hand briskly. “Yes, clever boy, that’s deep learning (深度学习/深度神经网络)”, says the director. “However, they are only ‘a piece of cake’. I won’t tell you a top secret that our lab has invented a Deep Monkey (深猴) with more advanced technology. And that guy is as smart as human!”
“Nani ?!” Little Tiger doubts about that as he is the smartest kid in his kindergarten; even so, he is not as smart as human, “how can a monkey be smarter than me? I will challenge him.”
To verify their research achievement, the researchers of the Deep Lab are going to host an intelligence test for Little Tiger and Deep Monkey.
The test is composed of N binary choice questions. And different questions may have different scores according to their difficulties. One can get the corresponding score for a question if he chooses the correct answer; otherwise, he gets nothing. The overall score is counted as the sum of scores one gets from each question. The one with a larger overall score wins; tie happens when they get the same score.
Little Tiger assumes that Deep Monkey will choose the answer randomly as he doesn’t believe the monkey is smart. Now, Little Tiger is wondering “what score should I get at least so that I will not lose in the contest with probability of at least P? ”. As little tiger is a really smart guy, he can evaluate the answer quickly.
You, Deep Monkey, can you work it out? Show your power!
Input
The first line of input contains a single integer T (1 ≤ T ≤ 10) indicating the number of test cases. Then T test cases follow.
Each test case is composed of two lines. The first line has two numbers N and P separated by a blank. N is an integer, satisfying 1 ≤ N ≤ 40. P is a floating number with at most 3 digits after the decimal point, and is in the range of [0, 1]. The second line has N numbers separated by blanks, which are the scores of each question. The score of each questions is an integer and in the range of [1, 1000]
Output
For each test case, output only a single line with the answer.
Sample Input
Sample Output
题意:
有A,B两个人答题比赛。一共有N道题目(N<=40)每道题有一个分值po[i](0<po[i]<=1000)。现假定B答对每到题的概率为0.5问A至少要得多少分才能保证不输给B的概率不小于P
解题思路:都说是概率dp,概率我不会,所以选择了另外一种方法,也用到了概率。由于对于每个题b的得分总是0.5,因此总共有2^n种情况,每种情况出现的概率是相同的,因此我们算出每个得分的情况数dp[i],然后算出当得分为多少时情况多于2^n *p。
#include <stdio.h>
#include <string.h>
#include <iostream>
//#define debug
using namespace std;
int a[105],n,dp[40005];
double p;
int main()
{
int T;
scanf("%d",&T);
while(T--)
{
scanf("%d%lf",&n,&p);
int sum=0;
for(int i=0; i<n; i++)
{
scanf("%d",&a[i]);
sum+=a[i];
}
memset(dp,0,sizeof(dp));
dp[0]=1;
for(int i=0;i<n;i++)
for(int j=sum;j>=a[i];j--)
dp[j]+=dp[j-a[i]];
#ifdef debug
for(int i=0;i<=sum;i++)
printf("%d: %d\n",i,dp[i]);
#endif
double num=0;
for(int i=0;i<=sum;i++)
{
num+=(dp[i]*1.0)/(1LL<<n);
if(num>=p)
{
printf("%d\n",i);
break;
}
}
}
return 0;
}